
#include "mbed.h"
#include "Credentials.h"

/** Right Trim whitespace from the string.
*
* @param p is a pointer to the string to modify.
*/
/** Get amount of free memory.
*
* @returns number of bytes of unused memory on the heap.
*/
// trim the trailing \r\n
static void RTrim(char *p) {
    while (*p >= ' ' && *p < 0x7F)
        p++;
    *p = '\0';
}


bool ReadCredentials(char * file, credentials * cr)
{
    FILE *fp = fopen(file, "r");

    cr->ssid = (char *)malloc(CREDENTIAL_SIZE);
    cr->pass = (char *)malloc(CREDENTIAL_SIZE);
    if (fp) {
        fgets(cr->ssid, CREDENTIAL_SIZE, fp);
        fgets(cr->pass, CREDENTIAL_SIZE, fp);
        fclose(fp);
        RTrim(cr->ssid);
        RTrim(cr->pass);
        return true;
    } else {
        return false;
    }
}

void FreeCredentials(credentials * cr)
{
    // first secure them by wiping them out
    for (int i=0; i<CREDENTIAL_SIZE; i++) {
        cr->ssid[i] = cr->pass[i] = '*';
    }
    // then free the memory
    free(cr->ssid);
    free(cr->pass);
}
